#include <stdlib.h>
#include <avr/pgmspace.h>
#include <Nokiatxt.h>


Nokia ecran;

// Affichage sur l'écran lcd et envoie sur la liaison RS232
void affichemesure(String a,float x, int ndec,String b){
char Str[10];
  String msg=a;
  if (x<0) {msg+='-'; x=-x; }
  int xi=int(x);
  itoa(xi,Str,10);  
  msg+=Str;
  if (ndec>0) {   msg+='.';
  for (int i=0;i<ndec;i++)   { x=10*(x-xi); xi=int(x); itoa(xi,Str,10); msg+=Str;  }
  }
 msg+=b;
 for (int i=msg.length();i<12;i++) msg+=' ';
 ecran.LcdString(msg);
  Serial.println(msg);
}

//****************  Mesures *****************//

#define ECH 39
#define pinPV A0     //courant PV
#define pinV A1     //tensionV1
#define pinA A2    // courant1
#define pinAA A3    // courant2
#define pinAAA A4     //courant3
//  A5    // point milieu

int pause=1;
  float I1valeff=0;  // Valeur efficace de I1 
  float I2valeff=0;  // Valeur efficace de I2 
  float I3valeff=0;  // Valeur efficace de I3 
  float Uvaleff=0;  // Valeur efficace de U
  float Puis=0;  // Puissance active
  float PuisS=0;  // Puissance apparente
  float PuisPV=0;  // Puissance apparente
  float IPVvaleff=0;  // Valeur efficace PV

int Tmax=20000; //us periode 50hz = 20ms = 20 000 us
int pt_milieu=0;  // valeur mesurée sur le point milieu des condensateurs ( 2.5V )
int coefIpince=1;  // conducteur passe dans la pince 1 fois


float calc(int a, int b){
  float fa,fb;
  fa=a;fb=b;
  return(fa*fb); // permet de calculer 2 entiers et de les stocker dans un réel
}


void mesureUI(){
int valuesA[ECH];  // memoire des mesures
int valuesB[ECH];
int valuesC[ECH];
int valuesD[ECH];
int valuesE[ECH];
unsigned long start_times;
unsigned long stop_times;
unsigned long _times;
pt_milieu=analogRead(A5);
 int i;
  byte min=255;
  start_times = micros();
  for(i=0;i<ECH;i+=1) {
    valuesA[i] = analogRead(pinV); // tension
    valuesB[i] = analogRead(pinA);  // courant phase1
    valuesC[i] = analogRead(pinAA);  // courant phase2
    valuesD[i] = analogRead(pinAAA);  // courant phase3
    
  } // calcule le temps pour faire toutes les mesures
   stop_times = micros();
  pause=Tmax-(stop_times - start_times);  // mesure dans le vide pour estimer la durée de toutes les mesures
  pause=pause/ECH; // calcul approximatif de la pause entre 2 mesures
  if (pause>=3) pause-=3; // reduit de 3us  pour refaire le calcul de la pause
 
  _times=0;
  while (_times<Tmax)
  {
  start_times = micros();
  for(i=0;i<ECH;i+=1) {
    valuesA[i] = analogRead(pinV);
    valuesB[i] = analogRead(pinA);
    valuesC[i] = analogRead(pinAA);
    valuesD[i] = analogRead(pinAAA);
    delayMicroseconds(pause);
  } // refais les mesures avec un echantillonnage regulier sur 20ms
  stop_times = micros();
  _times=stop_times - start_times;
  pause++; // recalcule l'intervalle précisement
  }

 float a=0;;float d=0;Puis=0;Uvaleff=0;I1valeff=0;I2valeff=0;I3valeff=0;PuisPV=0;
 //float aECH=ECH;
 float coefI=0.120; // faire une regle en fonction du capteur de courant
 float coefU=0.83; // même chose mais on utilise plutot le potentiometre
 float Itot=0;
  for(int i=0;i<ECH;i++) { valuesA[i]=valuesA[i]-pt_milieu; } // mesure des entrées et retrait du la valeur du point milieu ( condensateur )
  for(int i=0;i<ECH;i++) { valuesB[i]=valuesB[i]-pt_milieu; } // permet d'avoir une mesure négative et positive
  for(int i=0;i<ECH;i++) { valuesC[i]=valuesC[i]-pt_milieu; }
  for(int i=0;i<ECH;i++) { valuesD[i]=valuesD[i]-pt_milieu; }
//  for(int i=0;i<ECH;i++) { valuesC[i]=0; }
 // for(int i=0;i<ECH;i++) { valuesD[i]=0; }
  
  for(int i=0;i<ECH;i++) {    a=valuesB[i];    a=a*a;    I1valeff+=a/ECH;  }    I1valeff=sqrt(I1valeff)*coefI; // méthode TRMS pour les valeurs efficaces
  for(int i=0;i<ECH;i++) {    a=valuesC[i];    a=a*a;    I2valeff+=a/ECH;  }    I2valeff=sqrt(I2valeff)*coefI;
  for(int i=0;i<ECH;i++) {    a=valuesD[i];    a=a*a;    I3valeff+=a/ECH;  }    I3valeff=sqrt(I3valeff)*coefI;
  for(int i=0;i<ECH;i++) {    a=valuesA[i];    a=a*a;    Uvaleff+=a/ECH;  }    Uvaleff=sqrt(Uvaleff)*coefU;
  
 // triphase
  for(int i=0;i<ECH;i++) {
                    a=calc(valuesA[i],valuesB[i]);  Puis=Puis+a/ECH; //puissance sur 1      
           if(i<13) a=calc(valuesC[i],valuesA[i+26]); else a=calc(valuesC[i],valuesA[i-13]);   Puis=Puis+a/ECH; //puissance sur 3   
           if(i<26) a=calc(valuesD[i],valuesA[i+13]); else a=calc(valuesD[i],valuesA[i-26]);   Puis=Puis+a/ECH; //puissance sur 2   
   }
   //  monophase
   
  Puis=Puis*coefU*coefI;
/*
    for(int i=0;i<ECH;i++) {
                    a=calc(valuesA[i],valuesB[i]);  Puis=Puis+a/ECH; //puissance sur 1      // choisir ici vos résultats
                    a=calc(valuesA[i],valuesC[i]);  Puis=Puis+a/ECH; //puissance sur 1      
                    a=calc(valuesA[i],valuesD[i]);  Puis=Puis+a/ECH; //puissance sur 1      
           
   }
*/

  start_times = micros();
  for(i=0;i<ECH;i+=1) {
    valuesA[i] = analogRead(pinV);
     valuesE[i] = analogRead(pinPV);
    
  } // calcule le temps pour faire toutes les mesures
   stop_times = micros();
  pause=Tmax-(stop_times - start_times);
  pause=pause/ECH; // calcul approximatif de la pause entre 2 mesures
  if (pause>=3) pause-=3; // reduit de 3us
 
  _times=0;
  while (_times<Tmax)
  {
  start_times = micros();
  for(i=0;i<ECH;i+=1) {
    valuesA[i] = analogRead(pinV);
   valuesE[i] = analogRead(pinPV);
    delayMicroseconds(pause);
  } // refais les mesures avec un echantillonnage regulier sur 20ms
  stop_times = micros();
  _times=stop_times - start_times;
  pause++; // recalcule l'intervalle précisement
  }

 pt_milieu=analogRead(A5);
 for(int i=0;i<ECH;i++) { valuesE[i]=valuesE[i]-pt_milieu; }
  for(int i=0;i<ECH;i++) {   a=calc(valuesA[i],valuesE[i]);  PuisPV=PuisPV+a/ECH; } //puissance sur 1      
  PuisPV=PuisPV*coefU*coefI;


}


int pin3=3; // sortie pour regulation de puissance
float Puisav=0;
long testballon=30000; // commence mi-charge
long testnuit=0; // determine le mode jour/nuit
int testba=0;
int Temp_att=0;
int testradiateur=0;
int sortie_ce=0;

void regulPuis(){
  Puis=(5*Puisav+Puis)/6; // filtre les perturbations de puissance
  Puisav=Puis;
// regulation surplus dans le ballon 1000W maxi
 if (Puis<-100)  digitalWrite(pin3,HIGH); else digitalWrite(pin3,LOW);  // arret du surplus car la puissance est positive

// regulation de surplus dans radiateur
//**************************************
if ((Puis<-500) && (testradiateur<32)) 
  {
    testradiateur++;
    if (testradiateur==20) {  digitalWrite(pin3,LOW); } // couper le chauffe eau 2secondes
    if (testradiateur==30) { digitalWrite(2,LOW);  } // commande du relais
  }
 if ((PuisPV<500)||(Puis>-100)) {if (testradiateur>0) testradiateur--; }  // arret du surplus car la puissance est positive 1s
 if (testradiateur<20) { digitalWrite(2,HIGH);  } // coupe le relais

// remise en route du ballon 
//***************************
 if ((abs(PuisPV-(Uvaleff*I1valeff))<100)&&(Puis<-300))  {  if (testba<100) testba++; } else  {  testba=0; } // verification sur 10s
 if (testba>40)   { testballon=0; digitalWrite(7,HIGH); sortie_ce=0;}  // arret ballon
 if (testballon<800000) testballon++;  // limite de comptage
 if (testballon>700000) { sortie_ce=1; } // environ 5jours sans chauffage complet du ballon 20000 env 3h
 
 if (PuisPV>200) testnuit=0;    // si pv>0 on est le jour
 if (testnuit<30000)testnuit++;// limite de comptage
 if ((testnuit>20000)&&(sortie_ce==1)) digitalWrite(7,LOW); else digitalWrite(7,HIGH); // marche du ballon de nuit ( contact serie avec Heure Creuse ) 
}



//**************  Menu Principal *************

void setup(void){
  delay(500);                           // waits for the servo to get there
  Serial.begin(9600);
  pinMode(pin3, OUTPUT);       //triac gate control
  digitalWrite(pin3,LOW); //set triac gate to high
  pinMode(2, OUTPUT);      
  digitalWrite(2,HIGH); 
  pinMode(7, OUTPUT);       
  digitalWrite(7,HIGH); 
  delay(1000);
}


int affichage=3;

void loop(void){

 mesureUI(); // fait toutes les mesures
 regulPuis();
 if (affichage>5){ 
 ecran.gotoXY(0,0);
 affichemesure(F("Ueff="),Uvaleff,0,F("V"));
  affichemesure(F("P="),Puis,0,F("W"));
 affichemesure(F("I1="),I1valeff,2,F("A"));
 affichemesure(F("I2="),I2valeff,2,F("A"));
 affichemesure(F("I3="),I3valeff,2,F("A"));
 affichemesure(F("pv="),PuisPV,0,F("W")); 
 
 // affichage de l'état de chauffe du ballon
 ecran.gotoXY(0,0);
 if ((testballon>160000) &&(testballon<320000))  affichemesure(F("Ueff="),Uvaleff,0,F("V  *"));  // affichage ballon depuis 2j
 if ((testballon>1000) &&(testballon<160000))   affichemesure(F("Ueff="),Uvaleff,0,F("V **"));  // affichage ballon depuis 24h
 if ((testballon>0) &&(testballon<1000))        affichemesure(F("Ueff="),Uvaleff,0,F("V***"));  // ballon à température
 affichage=0;
 }
 affichage++;
  delay(200);

}
